; Environment.
#Persistent
#NoEnv
#SingleInstance, Ignore
SetBatchLines, -1
SetControlDelay, -1
DetectHiddenWindows, On
SetWorkingDir, %A_ScriptDir%

; Determine INI filename.
SplitPath, A_ScriptName, , , , ScriptNameNoExt, OutDrive
sConfigFile := A_ScriptDir . "\" . ScriptNameNoExt . ".ini"

; Create INI if it doesn't exist.
If ! FileExist( sConfigFile )
{
    sIniText =
    ( LTrim
        [Settings]
        IntervalMins=15
        Classname=ATH_Note    
    )
    FileAppend, % sIniText, % sConfigFile
}

; Read in parameters.
IniRead, nIntervalMins, % sConfigFile, Settings, IntervalMins, 15
IniRead, sClassname   , % sConfigFile, Settings, Classname   , ATH_Note

; Custom tray menu.
Menu, Tray, NoStandard
Menu, Tray, Add, Reload settings, Menu_Tray
Menu, Tray, Add,
Menu, Tray, Add, Exit  , Menu_Tray
Menu, Tray, Tip, Watching for classname: %sClassname%

; Initiate timer.
SetTimer, Reminder, % nIntervalMins * 60 * 1000

Return ; End of auto-execute section.


; ------------------------------------------------------------------------
; Hotkeys ----------------------------------------------------------------
; ------------------------------------------------------------------------

#IfWinActive, ahk_group HotkeyGroup
{
    Space:: Return
    ^s::
    {
        GoSub, GuiClose
        Gosub, ShowWindow
    }
    Return
}
#IfWinActive

; ------------------------------------------------------------------------
; Labels -----------------------------------------------------------------
; ------------------------------------------------------------------------

Reminder:
{
    WinGet, nClassnameCount, List, % "ahk_class " . sClassname

    If ( nClassnameCount )
    {
        
        ; Turn off timer so the message box doesn't keep appearing.
        SetTimer, Reminder, Off
        
        ; Set up grammar stuff for neatness.
        sQuestion := "There " . ( ( nClassnameCount = 1 ) ? ( "is" ) : ( "are" ) ) 
                   . " " . nClassnameCount . " " . sClassname
                   . " window" . ( ( nClassnameCount = 1 ) ? ( "" ) : ( "s" ) ) 
                   . "" . " opened.`n`nWhat would you like to do?"
                   
        sOption1 := "Show window" . ( ( nClassnameCount = 1 ) ? ( "" ) : ( "s" ) )
        sOption2 := "Cancel"
        
        ; Present GUI to user.
        GoSub, GuiMainBuild
        WinWaitClose, % "ahk_id " . GUI_ID
        
        ; Turn timer back on.
        SetTimer, Reminder, % nIntervalMins * 60 * 1000
    }
}
Return


GuiMainBuild:
{
    Gui +LastFound
    GUI_ID := WinExist()
    Gui, 1: +ToolWindow
    Gui, 1: Add, Picture, Icon222                               , Shell32.dll
    Gui, 1: Add, Text   , x+10 yp    w180 r8                    , % sQuestion
    Gui, 1: Add, Button , x+10 yp    w100    vbtnShow  gOnButton, % sOption1
    Gui, 1: Add, Button , x    yp+30 w100    vbtnCance gOnButton, % sOption2
    Gui, 1: Show
    
    ; Build a group for hotkeys later.
    GroupAdd, HotkeyGroup, % "ahk_id " . GUI_ID    
}
Return


GuiClose:
{
    Gui, 1: Destroy
}
Return


OnButton:
{
    If ( A_GuiControl = "btnShow" )
    {
        Gosub, ShowWindow
    }
    Gosub, GuiClose
}
Return


ShowWindow:
{
    Loop, % nClassnameCount
    {
        This_ID := nClassnameCount%A_Index%
        WinActivate, % "ahk_id " . This_ID
        ; ControlSend, , ^s, % "ahk_id " . This_ID
    }   
}
Return


Menu_Tray:
{
    If ( A_ThisMenuItem = "Reload settings" )
    {
        Reload
    }
    Else If ( A_ThisMenuItem = "Exit" )
    {
        ExitApp
    }
}
Return
